/* ptc.h (C) A. Zeuner 1996 */

#define PTC_READ_CH0		0x00
#define PTC_READ_CH1		0x40
#define PTC_READ_CH2		0x80
#define PTC_READ_BACK		0xC0

#define PTC_SET_CH0		0x30
#define PTC_SET_CH1		0x70
#define PTC_SET_CH2		0xB0

#define PTC_BCD			0x01
#define PTC_MODE0		0x00
#define PTC_MODE1		0x02
#define PTC_MODE2		0x04
#define PTC_MODE3		0x06
#define PTC_MODE4		0x08
#define PTC_MODE5		0x0A

#define PTC_CTRL_LATCH		0x00
#define PTC_RW_LO		0x10
#define PTC_RW_HI		0x20
#define PTC_RW_LOHI		0x30


extern inline void setptc
	(unsigned baseport, unsigned channel, unsigned mode, unsigned val)
{
  mode &=0x0f;
  switch (channel)  {
  case 0:
    mode |= 0x30;
    break;
  case 1:
    mode  |= 0x70;
    break;
  case 2:
    mode |= 0xb0;
    break;
  default:
    return;
  }
  outb(mode,baseport+3);
  outb((val & 0xff),baseport+channel);
  outb(((val>>8) & 0xff), baseport+channel);
}


extern inline unsigned readptc
	(unsigned baseport, unsigned channel)
{
  unsigned val;
  unsigned lo,hi;
  switch (channel) {
  case 0:
    val=0x0;
    break;
  case 1:
    val=0x40;
    break;
  case 2:
    val=0x80;
    break;
  default:
    return 0;
  }
  outb(val,baseport+3);
  lo=inb(baseport+channel);
  hi=inb(baseport+channel);
  return ((hi<<8)| lo);
}



#define setptc0(a,b,c)  setptc((a),0,(b),(c))
#define setptc1(a,b,c)  setptc((a),1,(b),(c))
#define setptc2(a,b,c)  setptc((a),2,(b),(c))


#define readptc0(a)	readptc((a),0)
#define readptc1(a)	readptc((a),1)
#define readptc2(a)	readptc((a),2)
