
#include <wsb.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <float.h>

#define  cfg(rc)  \
{ \
   short tst; \
if (rc) printf("(%s:%i)Last Call rc=%i\n",__FILE__,__LINE__,rc); \
rc=WsbGetConfig(&tst); \
printf("GetConfig:rc=%i tst=0x%04x\n",rc,tst); \
}



#define SIZE 256
int main(int argc,char* argv[])
{
   short src[SIZE];
   int i;
   int rc=0;
   double f,rf;
   unsigned short t[2];
   unsigned scale;
if (argc<2) {
   printf("Usage: %s f/[Hz]\n",argv[0]);
   return (1);
}
f=atof(argv[1]);
if (f==0.0) {
  fprintf(stderr,"argv[1]==0.0\n");
  return (2);
}
if (argc==3)  {
  scale=atoi(argv[2]);
  if (scale<=0 || scale > 127 ) {
  	fprintf(stderr,"argv[2]: %s",argv[2]);
  	return 3;
  }
} else {
	scale= 127;
}
for (i=0;i<SIZE;i++) {
   src[i]=(short)(sin(3.1414*2*i/(double)SIZE)*2048);
}
rc=WsbInit();
printf("rc: %i %s : %i\n",rc,__FILE__,__LINE__); 
rc=WsbPrepareA12MOutput(SIZE,src,src);
printf("rc: %i %s : %i\n",rc,__FILE__,__LINE__); 
rc=WsbScaleA12M(scale);
printf("rc: %i %s : %i\n",rc,__FILE__,__LINE__);
rc=WsbStartContOutput(0,SIZE,1,src,f);
printf("rc: %i %s : %i\n",rc,__FILE__,__LINE__); 
rc=WsbGetTimerFromFreq(f,t,t+1,&rf);
printf("rc: %i %s : %i\n",rc,__FILE__,__LINE__);
printf("Gewnschte Frequenz: %g t0=%u t1=%u -->f=%g\n",f,t[0],t[1],rf);
fgetc(stdin);
return(0);
}
