#if !defined ( __WSB_H__ )
#define __WSB_H__ 1

/* wsb.h (C) A. Zeuner 1997                            */
/* Based on my OS/2-Driver for WSB-100                 */

#if defined (__cplusplus)
extern "C" {
#endif

/* Category                                            */
#define WSB_IOCTL    0xA3
/* Functions
                                           */
#define _WSB_RESET             0x00
#define _WSB_SCALE_A12M        0x01
#define _WSB_WRITE_DATA         0x02 
#define _WSB_READ_DATA          0x03
#define _WSB_RUN                0x04
#define _WSB_STOP               0x05
#define _WSB_CONT               0x06
#define _WSB_NOCONT             0x07
#define _WSB_REPT               0x08
#define _WSB_NOREPT             0x09
#define _WSB_CLOCK              0x0A
#define _WSB_CLOCK_R            0x0B
#define _WSB_BASEMEM            0x0C
#define _WSB_POINTNR            0x0D
#define _WSB_DELAY              0x0E
#define _WSB_TRIGGERDELAY       0x0F
#define _WSB_SETDIR             0x10
#define _WSB_GETCONFIG          0x11
#define _WSB_RTRIG              0x12
 
#define WSB_RESET		_IO(WSB_IOCTL,_WSB_RESET)
#define WSB_SCALE_A12M		_IO(WSB_IOCTL,_WSB_SCALE_A12M)
#define WSB_WRITE_DATA		_IO(WSB_IOCTL,_WSB_WRITE_DATA) 
#define WSB_READ_DATA		_IO(WSB_IOCTL,_WSB_READ_DATA) 
#define WSB_RUN                 _IO(WSB_IOCTL,_WSB_RUN)
#define WSB_STOP		_IO(WSB_IOCTL,_WSB_STOP)
#define WSB_CONT		_IO(WSB_IOCTL,_WSB_CONT)
#define WSB_NOCONT		_IO(WSB_IOCTL,_WSB_NOCONT)
#define WSB_REPT		_IO(WSB_IOCTL,_WSB_REPT)
#define WSB_NOREPT		_IO(WSB_IOCTL,_WSB_NOREPT)
#define WSB_CLOCK		_IO(WSB_IOCTL,_WSB_CLOCK)
#define WSB_CLOCK_R		_IOR(WSB_IOCTL,_WSB_CLOCK_R,2*sizeof(short))
#define WSB_BASEMEM		_IO(WSB_IOCTL,_WSB_BASEMEM)
#define WSB_POINTNR		_IO(WSB_IOCTL,_WSB_POINTNR)
#define WSB_DELAY		_IO(WSB_IOCTL,_WSB_DELAY)
#define WSB_TRIGGERDELAY	_IO(WSB_IOCTL,_WSB_TRIGGERDELAY)
#define WSB_SETDIR		_IO(WSB_IOCTL,_WSB_SETDIR)
#define WSB_GETCONFIG		_IOR(WSB_IOCTL,_WSB_GETCONFIG,1*sizeof(short))
#define WSB_RTRIG		_IO(WSB_IOCTL,_WSB_RTRIG)





#if defined (__KERNEL__)

#define WSB_MAJOR	61

/* Definitionen fr den Zugriff auf die Kartenregister */


#define WSB_IOSIZE	0x10
#define W16_BASEMEM     0x00
#define W16_POINTNR     0x02
#define RW16_CONFIG     0x04
#define RW8_MODE        0x04
#define RW8_RESET       0x05
#define RW16_DATA       0x06
#define W16_CLOCKRATE   0x08
#define W16_DELAYCYCLES 0x0A
#define OFS_PIT         0x0C
#define RW8_PTC0        0x0C
#define RW8_PTC1        0x0D
#define RW8_PTC2        0x0E
#define RW8_CTLPTC      0x0F

/* Schreibender Zugriff auf das Kontrollregister */
#define RESET           0x8000
#define RUN             0x8000
#define BNC3            0x4000
#define BNC2            0x2000
#define TSRC            0x1000
#define RTRIG           0x0800
#define DELAY           0x0400
#define AREV            0x0200
#define DIR             0x0100
#define ADIR            0x0100

#define RESET_8         0x80
#define RUN_8           0x80
#define BNC3_8          0x40
#define BNC2_8          0x20
#define TSRC_8          0x10
#define RTRIG_8         0x08
#define DELAY_8         0x04
#define AREV_8          0x02
#define DIR_8           0x01
#define ADIR_8          0x01

#define SCALE           0x80
#define TRIGD           0x80
#define INT2            0x40
#define INT1            0x20
#define REPT            0x10
#define CONT            0x08
#define CSRC1           0x04
#define CSRC0           0x02
#define STARTRUN        0x01

#endif /* __KERNEL__ */

#if !defined (__KERNEL__)








